/***********************************************************
Copyright 1989 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/* $XConsortium: mispansZ.h,v 1.2 93/08/25 12:09:52 takamori Exp $ */
#include "ddpex.h"

typedef struct {
    int         count;		/* number of spans		    */
    ddCoord3DS  *points;	/* pointer to list of start points  */
    int         *widths;	/* pointer to list of widths	    */
    int         *depths;	/* pointer to list of depths	    */
} ZSpans;

typedef struct {
    int		size;		/* Total number of *Spans allocated	*/
    int		count;		/* Number of *Spans actually in group   */
    ZSpans       *group;	/* List of Spans			*/
    int		ymin, ymax;	/* Min, max y values encountered	*/
} ZSpanGroup;

/* Initialize SpanGroup.  MUST BE DONE before use. */
extern void miInitSpanGroupZ(/* spanGroup */);

/* Add a Spans to a SpanGroup. The spans MUST BE in y-sorted order */
extern void miAppendSpansZ(/* spanGroup, otherGroup, spans */);

/* Paint a span group, possibly with some overlap */
extern void miFillSpanGroupZ(/* spanGroup */);

/* Paint a span group, insuring that each pixel is painted at most once */
extern void miFillUniqueSpanGroupZ(/* spanGroup */);

/* Free up data in a span group.  MUST BE DONE or you'll suffer memory leaks */
extern void miFreeSpanGroupZ(/* spanGroup */);

/* Rops which must use span groups */
#define miSpansCarefulRopZ(rop)	(((rop) & 0xc) == 0x8 || ((rop) & 0x3) == 0x2)
#define miSpansEasyRopZ(rop)	(!miSpansCarefulRopZ(rop))
